{-# OPTIONS_GHC -w #-}
{-

Open Source Fixedpoint Model-Checker version 2010

(C) Copyright IBM Corp. 2010

All Rights Reserved.

Modifications by Paolo Modesti 2010

-}

module FPASLanParser where
import Data.Char
import Data.List
import FPASLanLexer
import Types
import Control.Applicative(Applicative(..))
import Control.Monad (ap)

-- parser produced by Happy Version 1.19.5

data HappyAbsSyn 
	= HappyTerminal (Token)
	| HappyErrorToken Int
	| HappyAbsSyn4 (PASLan)
	| HappyAbsSyn5 (PDefinitions)
	| HappyAbsSyn7 ([Typedec])
	| HappyAbsSyn8 ([PIdent])
	| HappyAbsSyn10 ([Vardec])
	| HappyAbsSyn13 (PType)
	| HappyAbsSyn16 ([PTerm])
	| HappyAbsSyn17 (PTerm)
	| HappyAbsSyn18 ([(PIdent,Int)])
	| HappyAbsSyn19 ([PRule])
	| HappyAbsSyn20 (PRule)
	| HappyAbsSyn21 ((PIdent, [Vardec]))
	| HappyAbsSyn22 (([PFact],[PCond],[PCond]))
	| HappyAbsSyn26 (PFact)

{- to allow type-synonyms as our monads (likely
 - with explicitly-specified bind and return)
 - in Haskell98, it seems that with
 - /type M a = .../, then /(HappyReduction M)/
 - is not allowed.  But Happy is a
 - code-generator that can just substitute it.
type HappyReduction m = 
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> m HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> m HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> [(Token)] -> m HappyAbsSyn
-}

action_0,
 action_1,
 action_2,
 action_3,
 action_4,
 action_5,
 action_6,
 action_7,
 action_8,
 action_9,
 action_10,
 action_11,
 action_12,
 action_13,
 action_14,
 action_15,
 action_16,
 action_17,
 action_18,
 action_19,
 action_20,
 action_21,
 action_22,
 action_23,
 action_24,
 action_25,
 action_26,
 action_27,
 action_28,
 action_29,
 action_30,
 action_31,
 action_32,
 action_33,
 action_34,
 action_35,
 action_36,
 action_37,
 action_38,
 action_39,
 action_40,
 action_41,
 action_42,
 action_43,
 action_44,
 action_45,
 action_46,
 action_47,
 action_48,
 action_49,
 action_50,
 action_51,
 action_52,
 action_53,
 action_54,
 action_55,
 action_56,
 action_57,
 action_58,
 action_59,
 action_60,
 action_61,
 action_62,
 action_63,
 action_64,
 action_65,
 action_66,
 action_67,
 action_68,
 action_69,
 action_70,
 action_71,
 action_72,
 action_73,
 action_74,
 action_75,
 action_76,
 action_77,
 action_78,
 action_79,
 action_80,
 action_81,
 action_82,
 action_83,
 action_84,
 action_85,
 action_86,
 action_87,
 action_88,
 action_89,
 action_90,
 action_91,
 action_92,
 action_93,
 action_94,
 action_95,
 action_96,
 action_97,
 action_98,
 action_99,
 action_100,
 action_101,
 action_102,
 action_103,
 action_104,
 action_105,
 action_106,
 action_107,
 action_108,
 action_109,
 action_110,
 action_111,
 action_112,
 action_113,
 action_114,
 action_115,
 action_116,
 action_117,
 action_118,
 action_119,
 action_120,
 action_121,
 action_122,
 action_123,
 action_124,
 action_125,
 action_126,
 action_127,
 action_128,
 action_129,
 action_130,
 action_131,
 action_132,
 action_133,
 action_134,
 action_135,
 action_136,
 action_137,
 action_138 :: () => Int -> ({-HappyReduction (HappyIdentity) = -}
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> (HappyIdentity) HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> (HappyIdentity) HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> [(Token)] -> (HappyIdentity) HappyAbsSyn)

happyReduce_1,
 happyReduce_2,
 happyReduce_3,
 happyReduce_4,
 happyReduce_5,
 happyReduce_6,
 happyReduce_7,
 happyReduce_8,
 happyReduce_9,
 happyReduce_10,
 happyReduce_11,
 happyReduce_12,
 happyReduce_13,
 happyReduce_14,
 happyReduce_15,
 happyReduce_16,
 happyReduce_17,
 happyReduce_18,
 happyReduce_19,
 happyReduce_20,
 happyReduce_21,
 happyReduce_22,
 happyReduce_23,
 happyReduce_24,
 happyReduce_25,
 happyReduce_26,
 happyReduce_27,
 happyReduce_28,
 happyReduce_29,
 happyReduce_30,
 happyReduce_31,
 happyReduce_32,
 happyReduce_33,
 happyReduce_34,
 happyReduce_35,
 happyReduce_36,
 happyReduce_37,
 happyReduce_38,
 happyReduce_39,
 happyReduce_40,
 happyReduce_41,
 happyReduce_42,
 happyReduce_43,
 happyReduce_44,
 happyReduce_45,
 happyReduce_46,
 happyReduce_47,
 happyReduce_48,
 happyReduce_49,
 happyReduce_50,
 happyReduce_51,
 happyReduce_52,
 happyReduce_53,
 happyReduce_54,
 happyReduce_55,
 happyReduce_56,
 happyReduce_57 :: () => ({-HappyReduction (HappyIdentity) = -}
	   Int 
	-> (Token)
	-> HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> (HappyIdentity) HappyAbsSyn)
	-> [HappyState (Token) (HappyStk HappyAbsSyn -> [(Token)] -> (HappyIdentity) HappyAbsSyn)] 
	-> HappyStk HappyAbsSyn 
	-> [(Token)] -> (HappyIdentity) HappyAbsSyn)

action_0 (30) = happyShift action_2
action_0 (4) = happyGoto action_3
action_0 _ = happyFail

action_1 (30) = happyShift action_2
action_1 _ = happyFail

action_2 (28) = happyShift action_4
action_2 _ = happyFail

action_3 (62) = happyAccept
action_3 _ = happyFail

action_4 (45) = happyShift action_5
action_4 _ = happyFail

action_5 (31) = happyShift action_6
action_5 _ = happyFail

action_6 (28) = happyShift action_9
action_6 (7) = happyGoto action_7
action_6 (9) = happyGoto action_8
action_6 _ = happyReduce_10

action_7 (32) = happyShift action_13
action_7 _ = happyFail

action_8 (46) = happyShift action_12
action_8 _ = happyFail

action_9 (47) = happyShift action_10
action_9 (61) = happyShift action_11
action_9 _ = happyReduce_13

action_10 (28) = happyShift action_29
action_10 (9) = happyGoto action_28
action_10 _ = happyFail

action_11 (28) = happyShift action_26
action_11 (48) = happyShift action_27
action_11 (12) = happyGoto action_24
action_11 (15) = happyGoto action_25
action_11 _ = happyFail

action_12 (28) = happyShift action_20
action_12 (39) = happyShift action_21
action_12 (40) = happyShift action_22
action_12 (48) = happyShift action_23
action_12 (13) = happyGoto action_18
action_12 (14) = happyGoto action_19
action_12 _ = happyFail

action_13 (28) = happyShift action_16
action_13 (50) = happyShift action_17
action_13 (16) = happyGoto action_14
action_13 (17) = happyGoto action_15
action_13 _ = happyFail

action_14 (45) = happyShift action_41
action_14 _ = happyFail

action_15 (47) = happyShift action_40
action_15 _ = happyReduce_29

action_16 (50) = happyShift action_38
action_16 (52) = happyShift action_39
action_16 _ = happyReduce_31

action_17 (28) = happyShift action_37
action_17 _ = happyFail

action_18 (45) = happyShift action_36
action_18 _ = happyFail

action_19 _ = happyReduce_22

action_20 _ = happyReduce_23

action_21 _ = happyReduce_24

action_22 _ = happyReduce_25

action_23 (28) = happyShift action_31
action_23 (8) = happyGoto action_35
action_23 _ = happyFail

action_24 _ = happyReduce_28

action_25 (45) = happyShift action_34
action_25 _ = happyFail

action_26 (56) = happyShift action_33
action_26 _ = happyReduce_19

action_27 (28) = happyShift action_31
action_27 (57) = happyShift action_32
action_27 (8) = happyGoto action_30
action_27 _ = happyFail

action_28 _ = happyReduce_14

action_29 (47) = happyShift action_10
action_29 _ = happyReduce_13

action_30 (49) = happyShift action_53
action_30 _ = happyFail

action_31 (47) = happyShift action_52
action_31 _ = happyReduce_11

action_32 (57) = happyShift action_51
action_32 _ = happyFail

action_33 (28) = happyShift action_26
action_33 (12) = happyGoto action_50
action_33 _ = happyFail

action_34 (28) = happyShift action_9
action_34 (7) = happyGoto action_49
action_34 (9) = happyGoto action_8
action_34 _ = happyReduce_10

action_35 (49) = happyShift action_48
action_35 _ = happyFail

action_36 (28) = happyShift action_9
action_36 (7) = happyGoto action_47
action_36 (9) = happyGoto action_8
action_36 _ = happyReduce_10

action_37 (51) = happyShift action_46
action_37 _ = happyFail

action_38 (28) = happyShift action_16
action_38 (50) = happyShift action_17
action_38 (16) = happyGoto action_45
action_38 (17) = happyGoto action_15
action_38 _ = happyFail

action_39 (28) = happyShift action_16
action_39 (50) = happyShift action_17
action_39 (16) = happyGoto action_44
action_39 (17) = happyGoto action_15
action_39 _ = happyFail

action_40 (28) = happyShift action_16
action_40 (50) = happyShift action_17
action_40 (16) = happyGoto action_43
action_40 (17) = happyGoto action_15
action_40 _ = happyFail

action_41 (33) = happyShift action_42
action_41 _ = happyFail

action_42 (34) = happyShift action_58
action_42 _ = happyFail

action_43 _ = happyReduce_30

action_44 (53) = happyShift action_57
action_44 _ = happyFail

action_45 (51) = happyShift action_56
action_45 _ = happyFail

action_46 _ = happyReduce_34

action_47 _ = happyReduce_8

action_48 _ = happyReduce_21

action_49 _ = happyReduce_9

action_50 _ = happyReduce_20

action_51 (57) = happyShift action_55
action_51 _ = happyFail

action_52 (28) = happyShift action_31
action_52 (8) = happyGoto action_54
action_52 _ = happyFail

action_53 _ = happyReduce_26

action_54 _ = happyReduce_12

action_55 (49) = happyShift action_61
action_55 _ = happyFail

action_56 _ = happyReduce_33

action_57 _ = happyReduce_32

action_58 (28) = happyShift action_60
action_58 (18) = happyGoto action_59
action_58 _ = happyFail

action_59 (45) = happyShift action_63
action_59 _ = happyFail

action_60 (54) = happyShift action_62
action_60 _ = happyFail

action_61 _ = happyReduce_27

action_62 (29) = happyShift action_65
action_62 _ = happyFail

action_63 (35) = happyShift action_64
action_63 _ = happyFail

action_64 (28) = happyShift action_60
action_64 (18) = happyGoto action_67
action_64 _ = happyFail

action_65 (47) = happyShift action_66
action_65 _ = happyReduce_35

action_66 (28) = happyShift action_60
action_66 (18) = happyGoto action_69
action_66 _ = happyFail

action_67 (45) = happyShift action_68
action_67 _ = happyFail

action_68 (36) = happyShift action_70
action_68 _ = happyFail

action_69 _ = happyReduce_36

action_70 (28) = happyShift action_60
action_70 (18) = happyGoto action_71
action_70 _ = happyFail

action_71 (45) = happyShift action_72
action_71 _ = happyFail

action_72 (38) = happyShift action_74
action_72 (5) = happyGoto action_73
action_72 _ = happyReduce_2

action_73 (37) = happyShift action_77
action_73 _ = happyFail

action_74 (28) = happyShift action_76
action_74 (6) = happyGoto action_75
action_74 _ = happyFail

action_75 _ = happyReduce_3

action_76 (46) = happyShift action_83
action_76 (50) = happyShift action_84
action_76 _ = happyFail

action_77 (28) = happyShift action_81
action_77 (55) = happyShift action_82
action_77 (62) = happyReduce_38
action_77 (19) = happyGoto action_78
action_77 (20) = happyGoto action_79
action_77 (21) = happyGoto action_80
action_77 _ = happyReduce_42

action_78 _ = happyReduce_1

action_79 (28) = happyShift action_81
action_79 (55) = happyShift action_82
action_79 (62) = happyReduce_38
action_79 (19) = happyGoto action_96
action_79 (20) = happyGoto action_79
action_79 (21) = happyGoto action_80
action_79 _ = happyReduce_42

action_80 (28) = happyShift action_94
action_80 (43) = happyShift action_95
action_80 (22) = happyGoto action_90
action_80 (24) = happyGoto action_91
action_80 (25) = happyGoto action_92
action_80 (26) = happyGoto action_93
action_80 _ = happyReduce_44

action_81 (52) = happyShift action_89
action_81 _ = happyFail

action_82 (28) = happyShift action_88
action_82 (11) = happyGoto action_87
action_82 _ = happyFail

action_83 (28) = happyShift action_16
action_83 (50) = happyShift action_17
action_83 (17) = happyGoto action_86
action_83 _ = happyFail

action_84 (28) = happyShift action_29
action_84 (9) = happyGoto action_85
action_84 _ = happyFail

action_85 (51) = happyShift action_110
action_85 _ = happyFail

action_86 (45) = happyShift action_109
action_86 _ = happyReduce_4

action_87 (57) = happyShift action_108
action_87 _ = happyFail

action_88 (47) = happyShift action_107
action_88 _ = happyReduce_17

action_89 (28) = happyShift action_106
action_89 (10) = happyGoto action_105
action_89 _ = happyFail

action_90 (58) = happyShift action_103
action_90 (59) = happyShift action_104
action_90 (27) = happyGoto action_102
action_90 _ = happyFail

action_91 (57) = happyShift action_101
action_91 _ = happyReduce_45

action_92 _ = happyReduce_49

action_93 _ = happyReduce_52

action_94 (41) = happyShift action_98
action_94 (42) = happyShift action_99
action_94 (52) = happyShift action_100
action_94 _ = happyReduce_55

action_95 (28) = happyShift action_29
action_95 (9) = happyGoto action_97
action_95 _ = happyFail

action_96 _ = happyReduce_37

action_97 (57) = happyShift action_124
action_97 _ = happyFail

action_98 (28) = happyShift action_16
action_98 (50) = happyShift action_17
action_98 (17) = happyGoto action_123
action_98 _ = happyFail

action_99 (28) = happyShift action_16
action_99 (50) = happyShift action_17
action_99 (17) = happyGoto action_122
action_99 _ = happyFail

action_100 (28) = happyShift action_16
action_100 (50) = happyShift action_17
action_100 (16) = happyGoto action_121
action_100 (17) = happyGoto action_15
action_100 _ = happyFail

action_101 (28) = happyShift action_94
action_101 (43) = happyShift action_95
action_101 (22) = happyGoto action_120
action_101 (24) = happyGoto action_91
action_101 (25) = happyGoto action_92
action_101 (26) = happyGoto action_93
action_101 _ = happyReduce_44

action_102 (28) = happyShift action_119
action_102 (23) = happyGoto action_117
action_102 (25) = happyGoto action_118
action_102 (26) = happyGoto action_93
action_102 _ = happyReduce_47

action_103 _ = happyReduce_56

action_104 (28) = happyShift action_29
action_104 (9) = happyGoto action_116
action_104 _ = happyFail

action_105 (53) = happyShift action_115
action_105 _ = happyFail

action_106 (46) = happyShift action_114
action_106 _ = happyFail

action_107 (28) = happyShift action_88
action_107 (11) = happyGoto action_113
action_107 _ = happyFail

action_108 _ = happyReduce_40

action_109 (28) = happyShift action_76
action_109 (6) = happyGoto action_112
action_109 _ = happyFail

action_110 (46) = happyShift action_111
action_110 _ = happyFail

action_111 (28) = happyShift action_16
action_111 (50) = happyShift action_17
action_111 (17) = happyGoto action_131
action_111 _ = happyFail

action_112 _ = happyReduce_6

action_113 _ = happyReduce_18

action_114 (28) = happyShift action_20
action_114 (39) = happyShift action_21
action_114 (40) = happyShift action_22
action_114 (14) = happyGoto action_130
action_114 _ = happyFail

action_115 _ = happyReduce_41

action_116 (60) = happyShift action_129
action_116 _ = happyFail

action_117 (45) = happyShift action_128
action_117 _ = happyFail

action_118 (57) = happyShift action_127
action_118 _ = happyReduce_48

action_119 (42) = happyShift action_99
action_119 (52) = happyShift action_100
action_119 _ = happyReduce_55

action_120 _ = happyReduce_43

action_121 (53) = happyShift action_126
action_121 _ = happyFail

action_122 _ = happyReduce_53

action_123 _ = happyReduce_50

action_124 (28) = happyShift action_125
action_124 _ = happyFail

action_125 (41) = happyShift action_135
action_125 _ = happyFail

action_126 _ = happyReduce_54

action_127 (28) = happyShift action_119
action_127 (23) = happyGoto action_134
action_127 (25) = happyGoto action_118
action_127 (26) = happyGoto action_93
action_127 _ = happyReduce_47

action_128 _ = happyReduce_39

action_129 _ = happyReduce_57

action_130 (47) = happyShift action_133
action_130 _ = happyReduce_15

action_131 (45) = happyShift action_132
action_131 _ = happyReduce_5

action_132 (28) = happyShift action_76
action_132 (6) = happyGoto action_138
action_132 _ = happyFail

action_133 (28) = happyShift action_106
action_133 (10) = happyGoto action_137
action_133 _ = happyFail

action_134 _ = happyReduce_46

action_135 (28) = happyShift action_16
action_135 (50) = happyShift action_17
action_135 (17) = happyGoto action_136
action_135 _ = happyFail

action_136 _ = happyReduce_51

action_137 _ = happyReduce_16

action_138 _ = happyReduce_7

happyReduce_1 = happyReduce 21 4 happyReduction_1
happyReduction_1 ((HappyAbsSyn19  happy_var_21) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn5  happy_var_19) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn18  happy_var_17) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn18  happy_var_14) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn18  happy_var_11) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn16  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn7  happy_var_5) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn4
		 ((PASLan happy_var_2 happy_var_5 happy_var_7 happy_var_11 happy_var_14 happy_var_17 happy_var_19 happy_var_21)
	) `HappyStk` happyRest

happyReduce_2 = happySpecReduce_0  5 happyReduction_2
happyReduction_2  =  HappyAbsSyn5
		 ([]
	)

happyReduce_3 = happySpecReduce_2  5 happyReduction_3
happyReduction_3 (HappyAbsSyn5  happy_var_2)
	_
	 =  HappyAbsSyn5
		 (happy_var_2
	)
happyReduction_3 _ _  = notHappyAtAll 

happyReduce_4 = happySpecReduce_3  6 happyReduction_4
happyReduction_4 (HappyAbsSyn17  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn5
		 ([(happy_var_1,happy_var_3,[])]
	)
happyReduction_4 _ _ _  = notHappyAtAll 

happyReduce_5 = happyReduce 6 6 happyReduction_5
happyReduction_5 ((HappyAbsSyn17  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn8  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 ([(happy_var_1,happy_var_6,happy_var_3)]
	) `HappyStk` happyRest

happyReduce_6 = happyReduce 5 6 happyReduction_6
happyReduction_6 ((HappyAbsSyn5  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn17  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 (((happy_var_1,happy_var_3,[]):happy_var_5)
	) `HappyStk` happyRest

happyReduce_7 = happyReduce 8 6 happyReduction_7
happyReduction_7 ((HappyAbsSyn5  happy_var_8) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn17  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn8  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn5
		 (((happy_var_1,happy_var_6,happy_var_3):happy_var_8)
	) `HappyStk` happyRest

happyReduce_8 = happyReduce 5 7 happyReduction_8
happyReduction_8 ((HappyAbsSyn7  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn13  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn8  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (([(x,happy_var_3) | x <- happy_var_1] ++ happy_var_5)
	) `HappyStk` happyRest

happyReduce_9 = happyReduce 5 7 happyReduction_9
happyReduction_9 ((HappyAbsSyn7  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn13  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn7
		 (((happy_var_1,happy_var_3):happy_var_5)
	) `HappyStk` happyRest

happyReduce_10 = happySpecReduce_0  7 happyReduction_10
happyReduction_10  =  HappyAbsSyn7
		 ([]
	)

happyReduce_11 = happySpecReduce_1  8 happyReduction_11
happyReduction_11 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn8
		 ([happy_var_1]
	)
happyReduction_11 _  = notHappyAtAll 

happyReduce_12 = happySpecReduce_3  8 happyReduction_12
happyReduction_12 (HappyAbsSyn8  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn8
		 (happy_var_1:happy_var_3
	)
happyReduction_12 _ _ _  = notHappyAtAll 

happyReduce_13 = happySpecReduce_1  9 happyReduction_13
happyReduction_13 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn8
		 ([happy_var_1]
	)
happyReduction_13 _  = notHappyAtAll 

happyReduce_14 = happySpecReduce_3  9 happyReduction_14
happyReduction_14 (HappyAbsSyn8  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn8
		 ((happy_var_1:happy_var_3)
	)
happyReduction_14 _ _ _  = notHappyAtAll 

happyReduce_15 = happySpecReduce_3  10 happyReduction_15
happyReduction_15 (HappyAbsSyn13  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn10
		 ([(happy_var_1, happy_var_3)]
	)
happyReduction_15 _ _ _  = notHappyAtAll 

happyReduce_16 = happyReduce 5 10 happyReduction_16
happyReduction_16 ((HappyAbsSyn10  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn13  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn10
		 ((happy_var_1, happy_var_3) : happy_var_5
	) `HappyStk` happyRest

happyReduce_17 = happySpecReduce_1  11 happyReduction_17
happyReduction_17 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn10
		 ([(happy_var_1, UserTypeRef "")]
	)
happyReduction_17 _  = notHappyAtAll 

happyReduce_18 = happySpecReduce_3  11 happyReduction_18
happyReduction_18 (HappyAbsSyn10  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn10
		 ((happy_var_1, UserTypeRef "") : happy_var_3
	)
happyReduction_18 _ _ _  = notHappyAtAll 

happyReduce_19 = happySpecReduce_1  12 happyReduction_19
happyReduction_19 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn8
		 ([happy_var_1]
	)
happyReduction_19 _  = notHappyAtAll 

happyReduce_20 = happySpecReduce_3  12 happyReduction_20
happyReduction_20 (HappyAbsSyn8  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn8
		 ((happy_var_1:happy_var_3)
	)
happyReduction_20 _ _ _  = notHappyAtAll 

happyReduce_21 = happySpecReduce_3  13 happyReduction_21
happyReduction_21 _
	(HappyAbsSyn8  happy_var_2)
	_
	 =  HappyAbsSyn13
		 (Enum happy_var_2
	)
happyReduction_21 _ _ _  = notHappyAtAll 

happyReduce_22 = happySpecReduce_1  13 happyReduction_22
happyReduction_22 (HappyAbsSyn13  happy_var_1)
	 =  HappyAbsSyn13
		 (happy_var_1
	)
happyReduction_22 _  = notHappyAtAll 

happyReduce_23 = happySpecReduce_1  14 happyReduction_23
happyReduction_23 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn13
		 (UserTypeRef happy_var_1
	)
happyReduction_23 _  = notHappyAtAll 

happyReduce_24 = happySpecReduce_1  14 happyReduction_24
happyReduction_24 _
	 =  HappyAbsSyn13
		 (Value
	)

happyReduce_25 = happySpecReduce_1  14 happyReduction_25
happyReduction_25 _
	 =  HappyAbsSyn13
		 (Untyped
	)

happyReduce_26 = happySpecReduce_3  15 happyReduction_26
happyReduction_26 _
	(HappyAbsSyn8  happy_var_2)
	_
	 =  HappyAbsSyn13
		 (EnumType happy_var_2
	)
happyReduction_26 _ _ _  = notHappyAtAll 

happyReduce_27 = happyReduce 5 15 happyReduction_27
happyReduction_27 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn13
		 (CountType
	) `HappyStk` happyRest

happyReduce_28 = happySpecReduce_1  15 happyReduction_28
happyReduction_28 (HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn13
		 (Union happy_var_1
	)
happyReduction_28 _  = notHappyAtAll 

happyReduce_29 = happySpecReduce_1  16 happyReduction_29
happyReduction_29 (HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn16
		 ([happy_var_1]
	)
happyReduction_29 _  = notHappyAtAll 

happyReduce_30 = happySpecReduce_3  16 happyReduction_30
happyReduction_30 (HappyAbsSyn16  happy_var_3)
	_
	(HappyAbsSyn17  happy_var_1)
	 =  HappyAbsSyn16
		 ((happy_var_1:happy_var_3)
	)
happyReduction_30 _ _ _  = notHappyAtAll 

happyReduce_31 = happySpecReduce_1  17 happyReduction_31
happyReduction_31 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn17
		 (PAtom happy_var_1
	)
happyReduction_31 _  = notHappyAtAll 

happyReduce_32 = happyReduce 4 17 happyReduction_32
happyReduction_32 (_ `HappyStk`
	(HappyAbsSyn16  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn17
		 (PComp happy_var_1 happy_var_3
	) `HappyStk` happyRest

happyReduce_33 = happyReduce 4 17 happyReduction_33
happyReduction_33 (_ `HappyStk`
	(HappyAbsSyn16  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn17
		 (PPar happy_var_1 happy_var_3
	) `HappyStk` happyRest

happyReduce_34 = happySpecReduce_3  17 happyReduction_34
happyReduction_34 _
	(HappyTerminal (Tident _ happy_var_2))
	_
	 =  HappyAbsSyn17
		 (PParId happy_var_2
	)
happyReduction_34 _ _ _  = notHappyAtAll 

happyReduce_35 = happySpecReduce_3  18 happyReduction_35
happyReduction_35 (HappyTerminal (Tint _ happy_var_3))
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn18
		 ([(happy_var_1,happy_var_3)]
	)
happyReduction_35 _ _ _  = notHappyAtAll 

happyReduce_36 = happyReduce 5 18 happyReduction_36
happyReduction_36 ((HappyAbsSyn18  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tint _ happy_var_3)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn18
		 ((happy_var_1,happy_var_3):happy_var_5
	) `HappyStk` happyRest

happyReduce_37 = happySpecReduce_2  19 happyReduction_37
happyReduction_37 (HappyAbsSyn19  happy_var_2)
	(HappyAbsSyn20  happy_var_1)
	 =  HappyAbsSyn19
		 (happy_var_1:happy_var_2
	)
happyReduction_37 _ _  = notHappyAtAll 

happyReduce_38 = happySpecReduce_0  19 happyReduction_38
happyReduction_38  =  HappyAbsSyn19
		 ([]
	)

happyReduce_39 = happyReduce 5 20 happyReduction_39
happyReduction_39 (_ `HappyStk`
	(HappyAbsSyn22  happy_var_4) `HappyStk`
	(HappyAbsSyn8  happy_var_3) `HappyStk`
	(HappyAbsSyn22  happy_var_2) `HappyStk`
	(HappyAbsSyn21  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn20
		 ((\ (nm,env) (lf,lp,ln) (rf,rp,_) ->
      PRule { ruleName = nm, ruleEnv = env,
              lf = lf, lp = lp, ln = ln,
              fresh = happy_var_3, rf = rf, rp = rp }) happy_var_1 happy_var_2 happy_var_4
	) `HappyStk` happyRest

happyReduce_40 = happySpecReduce_3  21 happyReduction_40
happyReduction_40 _
	(HappyAbsSyn10  happy_var_2)
	_
	 =  HappyAbsSyn21
		 (("lambda", happy_var_2)
	)
happyReduction_40 _ _ _  = notHappyAtAll 

happyReduce_41 = happyReduce 4 21 happyReduction_41
happyReduction_41 (_ `HappyStk`
	(HappyAbsSyn10  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn21
		 ((happy_var_1, happy_var_3)
	) `HappyStk` happyRest

happyReduce_42 = happySpecReduce_0  21 happyReduction_42
happyReduction_42  =  HappyAbsSyn21
		 (("lambda", [])
	)

happyReduce_43 = happySpecReduce_3  22 happyReduction_43
happyReduction_43 (HappyAbsSyn22  happy_var_3)
	_
	(HappyAbsSyn22  happy_var_1)
	 =  HappyAbsSyn22
		 (combside happy_var_1 happy_var_3
	)
happyReduction_43 _ _ _  = notHappyAtAll 

happyReduce_44 = happySpecReduce_0  22 happyReduction_44
happyReduction_44  =  HappyAbsSyn22
		 (([],[],[])
	)

happyReduce_45 = happySpecReduce_1  22 happyReduction_45
happyReduction_45 (HappyAbsSyn22  happy_var_1)
	 =  HappyAbsSyn22
		 (happy_var_1
	)
happyReduction_45 _  = notHappyAtAll 

happyReduce_46 = happySpecReduce_3  23 happyReduction_46
happyReduction_46 (HappyAbsSyn22  happy_var_3)
	_
	(HappyAbsSyn22  happy_var_1)
	 =  HappyAbsSyn22
		 (combside happy_var_1 happy_var_3
	)
happyReduction_46 _ _ _  = notHappyAtAll 

happyReduce_47 = happySpecReduce_0  23 happyReduction_47
happyReduction_47  =  HappyAbsSyn22
		 (([],[],[])
	)

happyReduce_48 = happySpecReduce_1  23 happyReduction_48
happyReduction_48 (HappyAbsSyn22  happy_var_1)
	 =  HappyAbsSyn22
		 (happy_var_1
	)
happyReduction_48 _  = notHappyAtAll 

happyReduce_49 = happySpecReduce_1  24 happyReduction_49
happyReduction_49 (HappyAbsSyn22  happy_var_1)
	 =  HappyAbsSyn22
		 (happy_var_1
	)
happyReduction_49 _  = notHappyAtAll 

happyReduce_50 = happySpecReduce_3  24 happyReduction_50
happyReduction_50 (HappyAbsSyn17  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn22
		 ([],[],[(PCond [] happy_var_1 happy_var_3)]
	)
happyReduction_50 _ _ _  = notHappyAtAll 

happyReduce_51 = happyReduce 6 24 happyReduction_51
happyReduction_51 ((HappyAbsSyn17  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_4)) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn8  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn22
		 ([],[],[(PCond happy_var_2 happy_var_4 happy_var_6)]
	) `HappyStk` happyRest

happyReduce_52 = happySpecReduce_1  25 happyReduction_52
happyReduction_52 (HappyAbsSyn26  happy_var_1)
	 =  HappyAbsSyn22
		 (([happy_var_1],[],[])
	)
happyReduction_52 _  = notHappyAtAll 

happyReduce_53 = happySpecReduce_3  25 happyReduction_53
happyReduction_53 (HappyAbsSyn17  happy_var_3)
	_
	(HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn22
		 ([],[(PCond [] happy_var_1 happy_var_3)],[]
	)
happyReduction_53 _ _ _  = notHappyAtAll 

happyReduce_54 = happyReduce 4 26 happyReduction_54
happyReduction_54 (_ `HappyStk`
	(HappyAbsSyn16  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (Tident _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn26
		 ((PFact happy_var_1 happy_var_3)
	) `HappyStk` happyRest

happyReduce_55 = happySpecReduce_1  26 happyReduction_55
happyReduction_55 (HappyTerminal (Tident _ happy_var_1))
	 =  HappyAbsSyn26
		 ((PFact happy_var_1 [])
	)
happyReduction_55 _  = notHappyAtAll 

happyReduce_56 = happySpecReduce_1  27 happyReduction_56
happyReduction_56 _
	 =  HappyAbsSyn8
		 ([]
	)

happyReduce_57 = happySpecReduce_3  27 happyReduction_57
happyReduction_57 _
	(HappyAbsSyn8  happy_var_2)
	_
	 =  HappyAbsSyn8
		 (happy_var_2
	)
happyReduction_57 _ _ _  = notHappyAtAll 

happyNewToken action sts stk [] =
	action 62 62 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	Tident _ happy_dollar_dollar -> cont 28;
	Tint _ happy_dollar_dollar -> cont 29;
	Tproblem _ -> cont 30;
	Ttypes _ -> cont 31;
	Tsets _ -> cont 32;
	Tfunctions _ -> cont 33;
	Tpublic _ -> cont 34;
	Tprivate _ -> cont 35;
	TFacts _ -> cont 36;
	TRules _ -> cont 37;
	TDefinitions _ -> cont 38;
	Tvalue _ -> cont 39;
	Tuntyped _ -> cont 40;
	Tnotin _ -> cont 41;
	Tin _ -> cont 42;
	Tforall _ -> cont 43;
	Texists _ -> cont 44;
	Tsemicolon _ -> cont 45;
	Tcolon _ -> cont 46;
	Tcomma _ -> cont 47;
	Topenbrace _ -> cont 48;
	Tclosebrace _ -> cont 49;
	Topensquare _ -> cont 50;
	Tclosesquare _ -> cont 51;
	Topenpar _ -> cont 52;
	Tclosepar _ -> cont 53;
	Tslash _ -> cont 54;
	Tlambda _ -> cont 55;
	Tunion _ -> cont 56;
	Tdot _ -> cont 57;
	Tarrow _ -> cont 58;
	Topenarrow _ -> cont 59;
	Tclosarrow _ -> cont 60;
	Tequal _ -> cont 61;
	_ -> happyError' (tk:tks)
	}

happyError_ 62 tk tks = happyError' tks
happyError_ _ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Functor HappyIdentity where
    fmap f (HappyIdentity a) = HappyIdentity (f a)

instance Applicative HappyIdentity where
    pure  = return
    (<*>) = ap
instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [(Token)] -> HappyIdentity a
happyError' = HappyIdentity . happyError

parser tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn4 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


happyError :: [Token] -> a
happyError tks = error ("Parse error at " ++ lcn ++ "\n" )
	where
	lcn = 	case tks of
		  [] -> "end of file"
		  tk:_ -> "line " ++ show l ++ ", column " ++ show c ++ " - Token: " ++ show tk
			where
			AlexPn _ l c = token_posn tk
{-# LINE 1 "templates/GenericTemplate.hs" #-}


















-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

























infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
         (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
         sts1@(((st1@(HappyState (action))):(_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k ((st):(sts)) of
        sts1@(((st1@(HappyState (action))):(_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k ((st):(sts)) of
        sts1@(((st1@(HappyState (action))):(_))) ->
         let drop_stk = happyDropStk k stk





             new_state = action

          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction









happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail (1) tk old_st _ stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
        action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.









{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.

